--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--         CORPS DE LA PROCEDURE DE REEQUILIBRAGE           --
--         D'UN ARBRE BINAIRE DE RECHERCHE POINTE           --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

with Ada.Tags;
with Erreurs_Types_Abstraits; use Erreurs_Types_Abstraits;
procedure Arbres_Binaires.De_Recherche.Reequilibrer 
                                   (L_Arbre: in out Arbre_Rech) is
  use Ada.Tags;
  Nb_Noeud: Natural := 0;	   -- pour compter les noeuds 
  procedure Arbre_Partiel (Nb: Natural; P: out Pt_Noeud) is
    Nb_G: Natural;
    R: Pt_Noeud;
  begin
    if Nb = 0 then P := null;
    else
      Nb_G := (Nb - 1) / 2;
      Arbre_Partiel (Nb_G, R);
      L_Arbre.Chemin(L_arbre.Sommet).Le_Noeud.Gauche := R;
      R := L_Arbre.Chemin(L_arbre.Sommet).Le_Noeud;
      Passer_Au_Suivant (L_Arbre);
      Arbre_Partiel (Nb - Nb_G - 1, R.Droite);
      P := R;
    end if;
  end Arbre_Partiel;
begin
  if Arbre_Rech'Class(L_Arbre)'Tag /= Arbre_Rech'Tag then
    raise Erreur_Specification;
  end if;
  Positionner_Sur_Premier (L_Arbre);
  while not A_La_Fin (L_Arbre) loop     -- compter les noeuds
    Passer_Au_Suivant (L_Arbre);
    Nb_Noeud := Nb_Noeud + 1;
  end loop;
  Positionner_Sur_Premier (L_Arbre);
  Arbre_Partiel (Nb_Noeud, L_Arbre.Chemin(1).Le_Noeud);
  L_Arbre.Sommet := 0;
end Arbres_Binaires.De_Recherche.Reequilibrer;
