--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                 CORPS DU PAQUETAGE FILE                  --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

package body File is
  subtype Indice is Integer range 1..Taille + 1;
  Table : array (Indice) of Element;
  Tete, Queue : Indice := 1;

  procedure Vider is
  begin
    Tete := 1;
    Queue := 1;
  end Vider;

  function Est_Vide return Boolean is
  begin
    return Tete = Queue;
  end Est_Vide;

  function Premier return Element is
  begin
    if Est_Vide then raise File_Vide; end if;
    return Table (Tete);
  end Premier;

  procedure Ajouter (V : in Element) is
    Suivant : Indice := (Queue mod Indice'Last) + 1;
  begin
    if Suivant = Tete then raise File_Pleine; end if;
    Table (Queue) := V;
    Queue := Suivant;
  end Ajouter;

  procedure Retirer is
  begin
    if Est_Vide then raise File_Vide; end if;
    Tete := (Tete mod Indice'Last) + 1;
  end Retirer;
end File;
