--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--               PAQUETAGE FILE CIRCULAIRE                  --
--                                                          --
-- Note: le paquetage ne definit quune seule file          --
-- preconditions                                            --
--    premier, retirer: not est_vide {=> file_vide}         --
-- proprietes fonctionnelles                                --
--    est_vide = #ajouter - #retirer = 0                    --
--    retirer (ajouter (f, e)) = f                          --
--    premier (ajouter (f, e)) = e                          --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

generic
  type Element is private;
package File_Circulaire is
  File_Vide : exception;
  procedure Vider ;
  function Est_Vide return Boolean;
  function Premier return Element;
  procedure Ajouter (V : in Element);
  procedure Retirer;
end File_Circulaire;
