--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--  CORPS DE LA PROCEDURE DE FUSION DE DEUX LISTES CHAINEES --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

procedure Listes_Chainees.Fusion (L1, L2, L3 : in out Liste) is
  Q1 : Pt_Place := L1.Tete;
  Q2 : Pt_Place := L2.Tete;
  Q3 : Pt_Place; 
begin
  if Q1 = null then L3.Tete := Q2;
  elsif Q2 = null then L3.Tete := Q1; 
  else
    if Q1.Contenu < Q2.Contenu then
      L3.Tete := Q1; Q1 := Q1.Suivant;
    else
      L3.Tete := Q2; Q2 := Q2.Suivant;
    end if;
    Q3 := L3.Tete;
    while Q1 /= null and Q2 /= null loop
      if Q1.Contenu < Q2.Contenu then
        Q3.Suivant := Q1;			 -- insrer au bout de L3
        Q1 := Q1.Suivant;				   -- supprimer de L1
      else
        Q3.Suivant := Q2;			 -- insrer au bout de L3
        Q2 := Q2.Suivant;				   -- supprimer de L2
      end if;
      Q3 := Q3.Suivant;					   -- avancer dans L3
    end loop;
    Q3.Suivant := Q1;			 -- on raccroche la fin de L1
    if Q2 /= null then
      Q3.Suivant := Q2;			 -- on raccroche la fin de L2
    end if;
  end if; 
  L3.Courant := L3.Tete;
  L3.Precedant := null;
  L3.Longueur := L1.Longueur + L2.Longueur;
  L1.Longueur := 0; L1.Tete := null; L1.Precedant := null;
  L1.Courant := null;	  -- L1 ne contient plus rien
  L2.Longueur := 0; L2.Tete := null; L2.Precedant := null;
  L2.Courant := null;	  -- L2 ne contient plus rien
end Listes_Chainees.Fusion;
