--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                CORPS DE LA PROCEDURE DE                  --
--                TRI DUNE LISTE CONTIGUE                  --
--         (methode par insertion dichotomique)             --
--                                                          --
-- proprietes fonctionnelles                                --
--    tri-ins-iter(l1, l) =                                 --
--        si l = listevide alors l1                         --
--        sinon tri-ins-iter(placer(premier(l),l1), fin(l)) --
--        fsi                                               --
--    tri (l) = tri-ins-iter(listevide, l)                  --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

procedure Listes_Contigues.Tri_Liste(La_Liste: in out Liste)is
                            -- tri par insertion dichotomique
  subtype Indice is Positive range La_Liste.Ieme'Range;
  U : Element;
  L : Indice;
  function Recherche_Dicho (Dernier : in Indice)
                                            return Indice is
    Debut : Indice := 1;
    Milieu : Indice;
    Fin : Indice := Dernier;
  begin
    while Debut < Fin loop
      Milieu := (Debut + Fin) / 2;
      if La_Liste.Ieme (Milieu) < U then Debut := Milieu + 1;
      else Fin := Milieu;
      end if;
    end loop;
    return Debut;
  end Recherche_Dicho;
begin
  for K in Indice range 2 .. La_Liste.Longueur loop
    if La_Liste.Ieme (K) < La_Liste.Ieme (K - 1) then
      U := La_Liste.Ieme (K);       -- il n'est pas  sa place
      L := Recherche_Dicho (K - 1);    -- recherche de sa place
      La_Liste.Ieme(L + 1 .. K) := La_Liste.Ieme(L .. K - 1); 
      La_Liste.Ieme (L) := U;                     -- placement
    end if;
  end loop;
end Listes_Contigues.Tri_Liste;
