--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                CORPS DE LA PROCEDURE DE                  --
--                TRI DUNE LISTE CONTIGUE                  --
--         (methode par insertion sequentielle)             --
--                                                          --
-- proprietes fonctionnelles                                --
--    tri-ins-iter(l1, l) =                                 --
--        si l = listevide alors l1                         --
--        sinon tri-ins-iter(placer(premier(l),l1), fin(l)) --
--        fsi                                               --
--    tri (l) = tri-ins-iter(listevide, l)                  --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

procedure Listes_Contigues.Tri_Liste(La_Liste: in out Liste)is
                            -- tri par insertion squentielle
  subtype Indice is Positive range La_Liste.Ieme'Range;
  U : Element;
  L : Indice;
begin
  for K in Indice range 2 .. La_Liste.Longueur loop
    U := La_Liste.Ieme (K);                -- placement du Kime
    L := K;                           -- premire place possible
    while L /= 1 and then U < La_Liste.Ieme (L - 1) loop
      La_Liste.Ieme (L) := La_Liste.Ieme (L - 1);
                                        -- dplacement de L-1
      L := L - 1;                   -- nouvelle place possible
    end loop;
    La_Liste.Ieme (L) := U;                    -- c'est la bonne
  end loop;
end Listes_Contigues.Tri_Liste;
