--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                CORPS DE LA PROCEDURE DE                  --
--                TRI DUNE LISTE CONTIGUE                  --
--           (methode par selection ordinaire)              --
--                                                          --
-- proprietes fonctionnelles                                --
--    tri-sel-iter(l1, l) =                                 --
--        si l = listevide alors l1                         --
--        sinon tri-sel-iter(l1&[min(l)], supprimer-min(l)) --
--        fsi                                               --
--    tri (l) = tri-sel-iter(listevide, l)                  --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

procedure Listes_Contigues.Tri_Liste(La_Liste: in out Liste)is
                                  -- tri par slection simple
  subtype Indice is Positive range La_Liste.Ieme'Range;
  J : Indice;
  procedure Echanger (I, J : Indice) is
    U : Element := La_Liste.Ieme (J);
  begin
    La_Liste.Ieme (J) := La_Liste.Ieme (I);
    La_Liste.Ieme (I) := U;
  end Echanger;
begin
  for K in Indice range 1 .. La_Liste.Longueur - 1 loop
                             -- recherche du Kime plus grand
    J := K;                         -- premier candidat possible
    for L in Indice range K + 1 .. La_Liste.Longueur loop
      if La_Liste.Ieme (L) < La_Liste.Ieme (J) then
        J := L;                             -- candidat meilleur
      end if;
    end loop;
    Echanger (J, K);                             -- rangement
  end loop;
end Listes_Contigues.Tri_Liste;
