--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                 CORPS DU PAQUETAGE PILE                  --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

package body Pile is
  Table : array (1..Taille) of Element;
  Long : Integer range 0..Taille := 0;

  procedure Vider is
  begin
    Long := 0;
  end Vider;

  function Est_Vide return Boolean is
  begin
    return Long = 0;
  end Est_Vide;

  function Sommet return Element is
  begin
    if Long = 0 then raise Pile_Vide; end if;
    return Table (Long);
  end Sommet;

  procedure Empiler (V : in Element) is
  begin
    if Long = Taille then raise Pile_Pleine; end if;
    Long := Long + 1;
    Table (Long) := V;
  end Empiler;

  procedure Depiler is
  begin
    if Long = 0 then raise Pile_Vide; end if;
    Long := Long - 1;
  end Depiler;
end Pile;
