--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                     PAQUETAGE PILE                       --
--                                                          --
-- Note: le paquetage ne definit quune seule pile          --
-- preconditions                                            --
--    Sommet, Depiler: not est_vide {=> pile_vide}          --
--    empiler: #empiler - #depiler < Taille {=>pile_pleine} --
-- proprietes fonctionnelles                                --
--    est_vide = #empiler - #depiler = 0                    --
--    depiler (empiler (p, e)) = p                          --
--    sommet (empiler (p, e)) = e                           --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

generic
  Taille : Positive := 100;
  type Element is private;
package Pile is
  Pile_Pleine, Pile_Vide : exception;
  procedure Vider ;
  function Est_Vide return Boolean;
  function Sommet return Element;
  procedure Empiler (V : in Element);
  procedure Depiler;
end Pile;
