--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                CORPS DE LA PROCEDURE DE                  --
--       RECHERCHE DANS UNE TABLE DE VALEURS ORDONNEES      --
--               (implantation dichotomique)                --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

function Recherche_Contigue (Dans : in Table;
                        Val_Cle : in Cle) return Positive is
  Debut : Positive := 1;
  Milieu, Fin : Positive;
begin                            -- implantation dichotomique
  if Longueur (Dans) = 0 then return 1; end if;
  Fin := Longueur (Dans);
  if La_Cle (Ieme (Dans, Fin)) < Val_Cle then
    return Fin + 1;
  end if;
  while Debut < Fin loop
    Milieu := (Debut + Fin) / 2;
    if La_Cle (Ieme (Dans, Milieu)) < Val_Cle then
      Debut := Milieu + 1;
    else
      Fin := Milieu;
    end if;
  end loop;
  return Debut;
end Recherche_Contigue;
