--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--           SPECIFICATION DE LA PROCEDURE DE               --
--       RECHERCHE DANS UNE TABLE DE VALEURS ORDONNEES      --
--                                                          --
-- propriete fonctionnelle                                  --
--    retourne le rang du premier element de la Table ayant --
--    comme Cle Val_Cle s'il existe, ou la longueur de la   --
--    Table + 1 s'il n'existe pas                           --
--                                                          --
-- note: l'operation na besoin d'aucune connaissance sur   --
--    la representation de la Table: elle y accede au moyen --
--    des fonctions Ieme et Longueur                        --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

generic
  type Element is private;
  type Table (<>) is private;
  type Cle is private;
  with function La_Cle (E : in Element) return Cle is <>;
  with function "<"(U, V : in Cle) return Boolean is <>;
  with function Longueur(De:in Table) return Natural is <>;
  with function Ieme (Dans : in Table;
                     En : in Positive) return Element is <>;
function Recherche_Contigue (Dans : in Table;
                         Val_Cle : in Cle) return Positive;
