--------------------------------------------------------------
--                                                          --
--            MODULE DE STRUCTURES DE DONNEES               --
--                                                          --
--                   PAQUETAGE DES TABLES                   --
--                                                          --
-- preconditions                                            --
--    Ieme: Defini (De, En)                                 --
--    Changer_Ieme (De, En, Avec): De.Bi <= En <= De.Bs     --
-- proprietes                                               --
--    Ieme (Changer_Ieme(De, I, Avec), En) =                --
--       si En = I alors Avec sinon Ieme (De, En) fsi       --
--    Defini (De, En) = faux a la creation                  --
--    Defini (Changer_Ieme (De, I, Avec), En) =             --
--       si En = I alors vrai sinon Defini (De, En) fsi     --
--                                                          --
-- Auteur: Christian CARREZ,                                --
-- Structures de donnees en Java, C++ et Ada 95, Dunod, 1997--
-- Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   --
-- Derniere modification: 1 juillet 1997                    --
--------------------------------------------------------------

with Ada.Finalization;
generic
  type Element is private; -- type des lments de la table
package Tables is
  type Table (Bi, Bs : Integer) is limited private; 
  function Ieme (De : in Table; 
                  En : in Integer) return Element;
  procedure Changer_Ieme (De : in out Table; 
                           En : in Integer; 
                           Avec : in Element);
private
  type Place;
  type Pt_Place is access Place;
  type Table (Bi, Bs : Integer) is 
    new Ada.Finalization.Limited_Controlled with
    record   -- reprsentation effective du type table 
      Tete : Pt_Place := null;
    end record;
  procedure Finalize (T : in out Table);
end Tables;
